#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <strstream.h>

#include "util.h"

static char buf[9];

int ftlsb()
{
  return (*(short *)"\001\000" & 0x0001);
}

char* ftcat(const char* name, int i)
{
  ostrstream str(buf, 9);
  str << name << i << ends;
  return buf;
}

char* ftdupstr(const char* str)
{
  char* copy;
  if (str) {
    copy=new char[strlen(str)+1];
    strcpy(copy,str);
  }
  else
    copy=NULL;

  return copy;
}

char* fttoupper(const char* str)
{
  char* r = ftdupstr(str);
  char* ptr =r;
  while (*ptr) {
    *ptr = toupper(*ptr);
    ptr++;
  }
  return r;
}

char* fttolower(const char* str)
{
  char* r = ftdupstr(str);
  char* ptr =r;
  while (*ptr) {
    *ptr = tolower(*ptr);
    ptr++;
  }
  return r;
}

void ftswap2(char* src, char* dest) {
  *(dest  ) = *(src+1);
  *(dest+1) = *(src  );
}

void ftswap4(char* src, char* dest) {
  *(dest  ) = *(src+3);
  *(dest+1) = *(src+2);
  *(dest+2) = *(src+1);
  *(dest+3) = *(src  );
}

void ftswap8(char* src, char* dest) {
  *(dest  ) = *(src+7);
  *(dest+1) = *(src+6);
  *(dest+2) = *(src+5);
  *(dest+3) = *(src+4);
  *(dest+4) = *(src+3);
  *(dest+5) = *(src+2);
  *(dest+6) = *(src+1);
  *(dest+7) = *(src  );
}



